Imports System.IO.Ports

Public Class Form1
    Delegate Sub SetTextCallback(ByVal [text] As String)
    Dim B_F As Boolean = False
    Dim f4Time As ULong
    Dim f4Time_F As Boolean = False
    Dim OutText As String = ""
    Dim RCData(6000, 6) As Integer '23z`
    Dim RCData2(3000, 6) As Integer '23z`
    Dim ii As Integer 'zsNo
    Dim gM As Integer = 0 '[h


    Private Sub UpdateCOMPortList()
        Dim s As String
        Dim i As Integer
        Dim foundDifference As Boolean

        i = 0
        foundDifference = False

        If lstCOMPorts.Items.Count = SerialPort.GetPortNames().Length Then
            For Each s In SerialPort.GetPortNames()
                If lstCOMPorts.Items(i).Equals(s) = False Then
                    foundDifference = True
                End If
                i = i + 1
            Next s
        Else
            foundDifference = True
        End If
        If foundDifference = False Then
            Exit Sub
        End If
        lstCOMPorts.Items.Clear()
        For Each s In SerialPort.GetPortNames()
            lstCOMPorts.Items.Add(s)
        Next s
        lstCOMPorts.SelectedIndex = 0
    End Sub

    Private Sub UpdateCOMPortList2()
        Dim s As String
        Dim i As Integer
        Dim foundDifference As Boolean

        i = 0
        foundDifference = False

        If lstCOMPorts2.Items.Count = SerialPort.GetPortNames().Length Then
            For Each s In SerialPort.GetPortNames()
                If lstCOMPorts2.Items(i).Equals(s) = False Then
                    foundDifference = True
                End If
                i = i + 1
            Next s
        Else
            foundDifference = True
        End If
        If foundDifference = False Then
            Exit Sub
        End If
        lstCOMPorts2.Items.Clear()
        For Each s In SerialPort.GetPortNames()
            lstCOMPorts2.Items.Add(s)
        Next s
        lstCOMPorts2.SelectedIndex = 0
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        UpdateCOMPortList()
        UpdateCOMPortList2()

        Select Case gM
            Case 4
                F4()
        End Select

        
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Try
            SerialPort1.PortName = lstCOMPorts.Items(lstCOMPorts.SelectedIndex).ToString()
            SerialPort1.Open()

            btnConnect.Enabled = False
            lstCOMPorts.Enabled = False
            btnClose.Enabled = True
            txtDataReceived.Clear()
            txtDataReceived.AppendText("Connected." + vbCrLf)
        Catch ex As Exception
            btnClose_Click(Me, e)

        End Try
    End Sub

    Private Sub btnConnect2_Click(sender As System.Object, e As System.EventArgs) Handles btnConnect2.Click
        Try
            SerialPort2.PortName = lstCOMPorts2.Items(lstCOMPorts2.SelectedIndex).ToString()
            SerialPort2.Open()

            btnConnect2.Enabled = False
            lstCOMPorts2.Enabled = False
            btnClose2.Enabled = True
            txtDataReceived2.Clear()
            txtDataReceived2.AppendText("Connected." + vbCrLf)
        Catch ex As Exception
            btnClose2_Click(Me, e)

        End Try

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        btnClose.Enabled = False
        btnConnect.Enabled = True
        lstCOMPorts.Enabled = True
        Try
            SerialPort1.DiscardInBuffer()
            SerialPort1.DiscardOutBuffer()
            SerialPort1.Close()
        Catch ex As Exception
        End Try
    End Sub
    Private Sub btnClose2_Click(sender As System.Object, e As System.EventArgs) Handles btnClose2.Click
        btnClose2.Enabled = False
        btnConnect2.Enabled = True
        lstCOMPorts2.Enabled = True
        Try
            SerialPort2.DiscardInBuffer()
            SerialPort2.DiscardOutBuffer()
            SerialPort2.Close()
        Catch ex As Exception
        End Try

    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Try
            Dim ReceivedText As String = SerialPort1.ReadExisting()
            If B_F Then

                Dim str As String = ConvertStr(ReceivedText)

                SetText(str & vbCrLf)
                B_F = False
            Else
                SetText(ReceivedText)
                'TextBox_T1.Text = DateTime.Now
            End If
        Catch ex As Exception
            btnClose_Click(Me, e)
        End Try

    End Sub
    Private Sub SerialPort2_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort2.DataReceived
        Try
            Dim ReceivedText As String = SerialPort2.ReadExisting()
            If B_F Then

                Dim str As String = ConvertStr(ReceivedText)

                SetText2(str & vbCrLf)
                B_F = False
            Else
                SetText2(ReceivedText)
                'TextBox_T2.Text = DateTime.Now
            End If

        Catch ex As Exception
            btnClose2_Click(Me, e)
        End Try

    End Sub

    Private Sub SetText(ByVal [text] As String)
        If txtDataReceived.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText)
            Invoke(d, New Object() {[text]})
        Else
            txtDataReceived.AppendText(text)
        End If
    End Sub

    Private Sub SetText2(ByVal [text] As String)
        If txtDataReceived2.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText2)
            Invoke(d, New Object() {[text]})
        Else
            txtDataReceived2.AppendText(text)
        End If
    End Sub

    Private Sub btnSendData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendData.Click
        Try
            SerialPort1.Write(txtData.Text)
        Catch ex As Exception
            btnClose_Click(Me, e)
        End Try
    End Sub

    Private Sub btnSendData2_Click(sender As System.Object, e As System.EventArgs) Handles btnSendData2.Click
        Try
            SerialPort2.Write(txtData2.Text)
        Catch ex As Exception
            btnClose2_Click(Me, e)
        End Try
    End Sub

    Private Sub btnSendData_CL_Click(sender As System.Object, e As System.EventArgs) Handles btnSendData_CL.Click
        Try
            SerialPort1.Write(txtData.Text & vbCrLf)
        Catch ex As Exception
            btnClose_Click(Me, e)
        End Try
    End Sub

    Private Sub btnSendData_CL2_Click(sender As System.Object, e As System.EventArgs) Handles btnSendData_CL2.Click
        Try
            SerialPort2.Write(txtData2.Text & vbCrLf)
        Catch ex As Exception
            btnClose2_Click(Me, e)
        End Try
    End Sub

    Private Sub ButtonF1_1_Click(sender As System.Object, e As System.EventArgs) Handles ButtonF1_1.Click
        SerialPort1.Write(":7880010001FFFFFFFFFFFFFFFF0E" & vbCrLf)
    End Sub

    Private Sub ButtonF1_2_Click(sender As System.Object, e As System.EventArgs) Handles ButtonF1_2.Click
        SerialPort2.Write(":7880010001FFFFFFFFFFFFFFFF0E" & vbCrLf)
    End Sub

    Private Sub ButtonF2_1_Click(sender As System.Object, e As System.EventArgs) Handles ButtonF2_1.Click

        Dim SendByte(256) As Byte
        'Shift JISƂĕϊ
        SendByte = System.Text.Encoding.GetEncoding(932).GetBytes(txtData.Text)
        Dim SendText As String = ""
        Dim i As Integer
        For i = 0 To SendByte.Length - 1
            SendText = SendText & Hex(SendByte(i))
        Next
        B_F = True
        SerialPort1.Write(SendText)
    End Sub

    Private Sub ButtonF2_2_Click(sender As System.Object, e As System.EventArgs) Handles ButtonF2_2.Click
        Dim SendByte(256) As Byte
        'Shift JISƂĕϊ
        SendByte = System.Text.Encoding.GetEncoding(932).GetBytes(txtData2.Text)
        Dim SendText As String = ""
        Dim i As Integer
        For i = 0 To SendByte.Length - 1
            SendText = SendText & Hex(SendByte(i))
        Next
        B_F = True
        SerialPort2.Write(SendText)

    End Sub

    Function ConvertStr(InText As String) As String
        Dim i, wk
        ConvertStr = ""
        For i = 1 To Len(InText) Step 2
            wk = Val("&H" & Mid(InText, i, 2))
            If wk > 127 Then
                wk = Val("&H" & Mid(InText, i, 4))
                i = i + 2
            End If
            ConvertStr = ConvertStr & Chr(wk)
        Next
    End Function

    Private Sub ButtonF3_1_Click(sender As System.Object, e As System.EventArgs) Handles ButtonF3_1.Click
        Dim SendByte(256) As Byte
        Dim SdText As String = "788001" & txtData.Text
        Dim Sum As UInt16 = 0
        Dim i

        For i = 0 To (SdText.Length / 2 - 1)
            Sum = Sum + CInt("&H" & Mid(SdText, 2 * i + 1, 2))
        Next

        Dim CSum As Byte = &H100 - (Sum And &HFF)
        Dim CSumH As Byte = CSum >> 4
        Dim CSumL As Byte = CSum And &HF

        SdText = ":" & SdText & Hex(CSumH) & Hex(CSumL) & vbCrLf
        SetText(vbCrLf & "M" & SdText)
        SerialPort1.Write(SdText)
    End Sub

    Private Sub ButtonF4_1_Click(sender As System.Object, e As System.EventArgs) Handles ButtonF4_1.Click
        SerialPort1.Write(":7880010001BBBBCCCCDDDDEEEE62" & vbCrLf)
        f4Time = 0
        f4Time_F = True
        OutText = ""
        txtDataReceived.Text = ""
        OutText = OutText & "(16i)" & vbTab & "NoOld(16i)" & vbTab & "NoNew(16i)" & vbTab & "x(x0.1%)" & vbTab & "x(0.1)" & vbCrLf
        ii = 0  'zsNo
        gM = 4 'F4s
    End Sub

    Private Sub txtDataReceived_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtDataReceived.TextChanged
        TextBox_T1.Text = DateTime.Now
    End Sub

    Private Sub txtDataReceived2_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtDataReceived2.TextChanged
        TextBox_T2.Text = DateTime.Now
    End Sub
    Sub F4()
        Dim Str As String
        Dim i As Long

        If f4Time_F = True Then f4Time = f4Time + 1

        If f4Time > Long.Parse(TextBox1.Text) * 60 Then
            f4Time = 0
            Str = String.Copy(txtDataReceived.Text)
            txtDataReceived.AppendText("END!!" + vbCrLf)
            f4Time_F = False
            'OutText = OutText & "(16i)" & vbTab & "NoOld(16i)" & vbTab & "NoNew(16i)" & vbTab & "x(x0.1%)" & vbTab & "x(0.1)" & vbCrLf
            For i = 1 To Str.Length - 5
                If Mid(Str, i, 5) = ":7881" Then
                    Try
                        RCData(ii, 0) = CInt("&H" & Mid(Str, i + 47, 4))
                        RCData(ii, 1) = CInt("&H" & Mid(Str, i + 51, 4))
                        RCData(ii, 2) = CInt("&H" & Mid(Str, i + 55, 4))
                        RCData(ii, 3) = CInt("&H" & Mid(Str, i + 59, 4))
                        RCData(ii, 4) = CInt("&H" & Mid(Str, i + 63, 4))
                        ii = ii + 1

                    Catch ex As Exception
                        RCData(ii, 0) = &HFFFF
                        RCData(ii, 1) = &HFFFF
                        RCData(ii, 2) = &HFFFF
                        RCData(ii, 3) = &HFFFF
                        RCData(ii, 4) = &HFFFF
                        ii = ii + 1

                    End Try

                    
                End If
            Next


            If RCData(ii - 1, 1) = RCData(ii - 1, 2) - 1 Then
                Dim j As Integer = 0
                For i = 0 To ii - 1
                    If RCData(i, 3) < 1000 And RCData(i, 4) < 1000 Then
                        RCData2(j, 0) = RCData(i, 0)
                        RCData2(j, 1) = RCData(i, 1)
                        RCData2(j, 2) = RCData(i, 2)
                        RCData2(j, 3) = RCData(i, 3)
                        RCData2(j, 4) = RCData(i, 4)
                        j = j + 1
                    End If
                Next

                Dim k As Integer
                RCData(0, 0) = RCData2(0, 0)
                RCData(0, 1) = RCData2(0, 1)
                RCData(0, 2) = RCData2(0, 2)
                RCData(0, 3) = RCData2(0, 3)
                RCData(0, 4) = RCData2(0, 4)
                For i = 1 To j - 1
                    If RCData2(i, 1) <> RCData(k, 1) Then
                        k = k + 1
                        RCData(k, 0) = RCData2(i, 0)
                        RCData(k, 1) = RCData2(i, 1)
                        RCData(k, 2) = RCData2(i, 2)
                        RCData(k, 3) = RCData2(i, 3)
                        RCData(k, 4) = RCData2(i, 4)
                    End If

                Next

                For i = 0 To k - 1
                    OutText = OutText & Hex(RCData(i, 0)) & vbTab & Hex(RCData(i, 1)) & vbTab & Hex(RCData(i, 2)) & vbTab & RCData(i, 3).ToString & vbTab & RCData(i, 4).ToString & vbCrLf
                Next

                If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
                    'OutText̓et@Cɏo
                    My.Computer.FileSystem.WriteAllText(SaveFileDialog1.FileName, OutText, append:=False)
                    OutText = ""
                End If
                gM = 0 'F4
            Else
                NexF4_1()
            End If
        End If
    End Sub
    Sub NexF4_1()
        SerialPort1.Write(":7880010001BBBBCCCCDDDDEEEE62" & vbCrLf)
        f4Time = 0
        f4Time_F = True
        txtDataReceived.Text = ""
    End Sub

End Class
